/[gentoo-x86]/eclass/eutils.eclass
Gentoo

Diff of /eclass/eutils.eclass

Parent Directory Parent Directory | Revision Log Revision Log | View Patch Patch

Revision 1.159 Revision 1.218
1# Copyright 1999-2005 Gentoo Foundation 1# Copyright 1999-2005 Gentoo Foundation
2# Distributed under the terms of the GNU General Public License v2 2# Distributed under the terms of the GNU General Public License v2
3# $Header: /var/cvsroot/gentoo-x86/eclass/eutils.eclass,v 1.159 2005/03/18 22:50:26 vapier Exp $ 3# $Header: /var/cvsroot/gentoo-x86/eclass/eutils.eclass,v 1.218 2005/11/22 11:15:34 flameeyes Exp $
4# 4#
5# Author: Martin Schlemmer <azarah@gentoo.org> 5# Author: Martin Schlemmer <azarah@gentoo.org>
6# 6#
7# This eclass is for general purpose functions that most ebuilds 7# This eclass is for general purpose functions that most ebuilds
8# have to implement themselves. 8# have to implement themselves.
9# 9#
10# NB: If you add anything, please comment it! 10# NB: If you add anything, please comment it!
11 11
12inherit multilib 12inherit multilib portability
13ECLASS=eutils
14INHERITED="$INHERITED $ECLASS"
15 13
16DEPEND="!bootstrap? ( sys-devel/patch )" 14DEPEND="!bootstrap? ( sys-devel/patch )"
15# sys-apps/shadow is needed for useradd, etc, bug #94745.
17 16
18DESCRIPTION="Based on the ${ECLASS} eclass" 17DESCRIPTION="Based on the ${ECLASS} eclass"
19
20# ecpu_check
21# Usage:
22#
23# ecpu_check array_of_cpu_flags
24#
25# array_of_cpu_flags - An array of cpu flags to check against USE flags
26#
27# Checks user USE related cpu flags against /proc/cpuinfo. If user enables a
28# cpu flag that is not supported in their processor flags, it will warn the
29# user if CROSSCOMPILE is not set to 1 ( because cross compile users are
30# obviously using different cpu flags than their own cpu ). Examples:
31#
32# CPU_FLAGS=(mmx mmx2 sse sse2)
33# ecpu_check CPU_FLAGS
34# Chris White <chriswhite@gentoo.org> (03 Feb 2005)
35
36ecpu_check() {
37 # Think about changing below to: if [ "${CROSSCOMPILE}" -ne 1 -a -e "/proc/cpuinfo" ]
38 # and dropping the else if you do not plan on adding anything to that
39 # empty block ....
40 # PS: also try to add some quoting, and consider rather using ${foo} than $foo ...
41 if [ "${CROSSCOMPILE}" != "1" -a -e "/proc/cpuinfo" ]
42 then
43 CPU_FLAGS=${1}
44 USER_CPU=`grep "flags" /proc/cpuinfo`
45
46 for flags in `seq 1 ${#CPU_FLAGS[@]}`
47 do
48 if has ${CPU_FLAGS[${flags} - 1]} ${USER_CPU} && ! has ${CPU_FLAGS[${flags} - 1]} ${USE}
49 then
50 ewarn "Your system is ${CPU_FLAGS[${flags} - 1]} capable but you don't have it enabled!"
51 ewarn "You might be cross compiling (in this case set CROSSCOMPILE to 1 to disable this warning."
52 fi
53
54 if ! has ${CPU_FLAGS[${flags} - 1]} ${USER_CPU} && has ${CPU_FLAGS[${flags} -1]} ${USE}
55 then
56 ewarn "You have ${CPU_FLAGS[${flags} - 1]} support enabled but your processor doesn't"
57 ewarn "Seem to support it! You might be cross compiling or do not have /proc filesystem"
58 ewarn "enabled. If either is the case, set CROSSCOMPILE to 1 to disable this warning."
59 fi
60 done
61 fi
62}
63 18
64# Wait for the supplied number of seconds. If no argument is supplied, defaults 19# Wait for the supplied number of seconds. If no argument is supplied, defaults
65# to five seconds. If the EPAUSE_IGNORE env var is set, don't wait. If we're not 20# to five seconds. If the EPAUSE_IGNORE env var is set, don't wait. If we're not
66# outputting to a terminal, don't wait. For compatability purposes, the argument 21# outputting to a terminal, don't wait. For compatability purposes, the argument
67# must be an integer greater than zero. 22# must be an integer greater than zero.
109gen_usr_ldscript() { 64gen_usr_ldscript() {
110 local libdir="$(get_libdir)" 65 local libdir="$(get_libdir)"
111 # Just make sure it exists 66 # Just make sure it exists
112 dodir /usr/${libdir} 67 dodir /usr/${libdir}
113 68
69 for lib in "${@}" ; do
114 cat > "${D}/usr/${libdir}/${1}" << END_LDSCRIPT 70 cat > "${D}/usr/${libdir}/${lib}" <<-END_LDSCRIPT
115/* GNU ld script 71 /* GNU ld script
116 Because Gentoo have critical dynamic libraries 72 Since Gentoo has critical dynamic libraries
117 in /lib, and the static versions in /usr/lib, we 73 in /lib, and the static versions in /usr/lib,
118 need to have a "fake" dynamic lib in /usr/lib, 74 we need to have a "fake" dynamic lib in /usr/lib,
119 otherwise we run into linking problems. 75 otherwise we run into linking problems.
120 See bug #4411 on http://bugs.gentoo.org/ for 76
121 more info. */ 77 See bug http://bugs.gentoo.org/4411 for more info.
78 */
122GROUP ( /${libdir}/${1} ) 79 GROUP ( /${libdir}/${lib} )
123END_LDSCRIPT 80 END_LDSCRIPT
124 fperms a+x "/usr/${libdir}/${1}" 81 fperms a+x "/usr/${libdir}/${lib}"
82 done
125} 83}
126 84
127# Simple function to draw a line consisting of '=' the same length as $* 85# Simple function to draw a line consisting of '=' the same length as $*
86# - only to be used by epatch()
128# 87#
129# <azarah@gentoo.org> (11 Nov 2002) 88# <azarah@gentoo.org> (11 Nov 2002)
130# 89#
131draw_line() { 90draw_line() {
132 local i=0 91 local i=0
158EPATCH_SOURCE="${WORKDIR}/patch" 117EPATCH_SOURCE="${WORKDIR}/patch"
159# Default extension for patches 118# Default extension for patches
160EPATCH_SUFFIX="patch.bz2" 119EPATCH_SUFFIX="patch.bz2"
161# Default options for patch 120# Default options for patch
162# Set -g0 to keep RCS, ClearCase, Perforce and SCCS happy. Bug #24571 121# Set -g0 to keep RCS, ClearCase, Perforce and SCCS happy. Bug #24571
163EPATCH_OPTS="-g0" 122# Set --no-backup-if-mismatch so we don't leave '.orig' files behind.
123EPATCH_OPTS="-g0 --no-backup-if-mismatch"
164# List of patches not to apply. Not this is only file names, 124# List of patches not to apply. Not this is only file names,
165# and not the full path .. 125# and not the full path ..
166EPATCH_EXCLUDE="" 126EPATCH_EXCLUDE=""
167# Change the printed message for a single patch. 127# Change the printed message for a single patch.
168EPATCH_SINGLE_MSG="" 128EPATCH_SINGLE_MSG=""
129# Change the printed message for multiple patches.
130EPATCH_MULTI_MSG="Applying various patches (bugfixes/updates) ..."
169# Force applying bulk patches even if not following the style: 131# Force applying bulk patches even if not following the style:
170# 132#
171# ??_${ARCH}_foo.${EPATCH_SUFFIX} 133# ??_${ARCH}_foo.${EPATCH_SUFFIX}
172# 134#
173EPATCH_FORCE="no" 135EPATCH_FORCE="no"
204# hand its a directory, it will set EPATCH_SOURCE to this. 166# hand its a directory, it will set EPATCH_SOURCE to this.
205# 167#
206# <azarah@gentoo.org> (10 Nov 2002) 168# <azarah@gentoo.org> (10 Nov 2002)
207# 169#
208epatch() { 170epatch() {
171 _epatch_assert() { local _pipestatus=${PIPESTATUS[*]}; [[ ${_pipestatus// /} -eq 0 ]] ; }
209 local PIPE_CMD="" 172 local PIPE_CMD=""
210 local STDERR_TARGET="${T}/$$.out" 173 local STDERR_TARGET="${T}/$$.out"
211 local PATCH_TARGET="${T}/$$.patch" 174 local PATCH_TARGET="${T}/$$.patch"
212 local PATCH_SUFFIX="" 175 local PATCH_SUFFIX=""
213 local SINGLE_PATCH="no" 176 local SINGLE_PATCH="no"
214 local x="" 177 local x=""
215 178
179 unset P4CONFIG P4PORT P4USER # keep perforce at bay #56402
180
216 if [ "$#" -gt 1 ] 181 if [ "$#" -gt 1 ]
217 then 182 then
218 local m="" 183 local m=""
219 einfo "${#} patches to apply ..."
220 for m in "$@" ; do 184 for m in "$@" ; do
221 epatch "${m}" 185 epatch "${m}"
222 done 186 done
223 return 0 187 return 0
224 fi 188 fi
278 ;; 242 ;;
279 esac 243 esac
280 244
281 if [ "${SINGLE_PATCH}" = "no" ] 245 if [ "${SINGLE_PATCH}" = "no" ]
282 then 246 then
283 einfo "Applying various patches (bugfixes/updates) ..." 247 einfo "${EPATCH_MULTI_MSG}"
284 fi 248 fi
285 for x in ${EPATCH_SOURCE} 249 for x in ${EPATCH_SOURCE}
286 do 250 do
287 # New ARCH dependant patch naming scheme ... 251 # New ARCH dependant patch naming scheme ...
288 # 252 #
289 # ???_arch_foo.patch 253 # ???_arch_foo.patch
290 # 254 #
291 if [ -f ${x} ] && \ 255 if [ -f ${x} ] && \
292 ([ "${SINGLE_PATCH}" = "yes" -o "${x/_all_}" != "${x}" -o "`eval echo \$\{x/_${ARCH}_\}`" != "${x}" ] || \ 256 ([ "${SINGLE_PATCH}" = "yes" -o "${x/_all_}" != "${x}" -o "${x/_${ARCH}_}" != "${x}" ] || \
293 [ "${EPATCH_FORCE}" = "yes" ]) 257 [ "${EPATCH_FORCE}" = "yes" ])
294 then 258 then
295 local count=0 259 local count=0
296 local popts="${EPATCH_OPTS}" 260 local popts="${EPATCH_OPTS}"
297 local patchname=${x##*/} 261 local patchname=${x##*/}
350 count=5 314 count=5
351 break 315 break
352 fi 316 fi
353 fi 317 fi
354 318
355 if (cat ${PATCH_TARGET} | patch -p${count} ${popts} --dry-run -f) >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 2>&1 319 if (cat ${PATCH_TARGET} | patch -p${count} ${popts} --dry-run -f ; _epatch_assert) >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 2>&1
356 then 320 then
357 draw_line "***** ${patchname} *****" > ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real 321 draw_line "***** ${patchname} *****" > ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
358 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real 322 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
359 echo "ACTUALLY APPLYING ${patchname} ..." >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real 323 echo "ACTUALLY APPLYING ${patchname} ..." >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
360 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real 324 echo >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
361 draw_line "***** ${patchname} *****" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real 325 draw_line "***** ${patchname} *****" >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real
362 326
363 cat ${PATCH_TARGET} | patch -p${count} ${popts} >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real 2>&1 327 cat ${PATCH_TARGET} | patch -p${count} ${popts} >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real 2>&1
328 _epatch_assert
364 329
365 if [ "$?" -ne 0 ] 330 if [ "$?" -ne 0 ]
366 then 331 then
367 cat ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/} 332 cat ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}.real >> ${STDERR_TARGET%/*}/${patchname}-${STDERR_TARGET##*/}
368 echo 333 echo
407 then 372 then
408 einfo "Done with patching" 373 einfo "Done with patching"
409 fi 374 fi
410} 375}
411 376
412# This function return true if we are using the NPTL pthreads
413# implementation.
414#
415# <azarah@gentoo.org> (06 March 2003)
416#
417have_NPTL() {
418 cat > ${T}/test-nptl.c <<-"END"
419 #define _XOPEN_SOURCE
420 #include <unistd.h>
421 #include <stdio.h>
422
423 int main()
424 {
425 char buf[255];
426 char *str = buf;
427
428 confstr(_CS_GNU_LIBPTHREAD_VERSION, str, 255);
429 if (NULL != str) {
430 printf("%s\n", str);
431 if (NULL != strstr(str, "NPTL"))
432 return 0;
433 }
434
435 return 1;
436 }
437 END
438
439 einfon "Checking for _CS_GNU_LIBPTHREAD_VERSION support in glibc ..."
440 if gcc -o ${T}/nptl ${T}/test-nptl.c &> /dev/null
441 then
442 echo "yes"
443 einfon "Checking what PTHREADS implementation we have ..."
444 if ${T}/nptl
445 then
446 return 0
447 else
448 return 1
449 fi
450 else
451 echo "no"
452 fi
453
454 return 1
455}
456
457# This function check how many cpu's are present, and then set
458# -j in MAKEOPTS accordingly.
459#
460# Thanks to nall <nall@gentoo.org> for this.
461#
462get_number_of_jobs() {
463 local jobs=0
464
465 if [ ! -r /proc/cpuinfo ]
466 then
467 return 1
468 fi
469
470 # This bit is from H?kan Wessberg <nacka-gentoo@refug.org>, bug #13565.
471 if [ "`egrep "^[[:space:]]*MAKEOPTS=" /etc/make.conf | wc -l`" -gt 0 ]
472 then
473 ADMINOPTS="`egrep "^[[:space:]]*MAKEOPTS=" /etc/make.conf | cut -d= -f2 | sed 's/\"//g'`"
474 ADMINPARAM="`echo ${ADMINOPTS} | gawk '{match($0, /-j *[0-9]*/, opt); print opt[0]}'`"
475 ADMINPARAM="${ADMINPARAM/-j}"
476 fi
477
478 export MAKEOPTS="`echo ${MAKEOPTS} | sed -e 's:-j *[0-9]*::g'`"
479
480 if [ "${ARCH}" = "amd64" -o "${ARCH}" = "x86" -o "${ARCH}" = "hppa" -o \
481 "${ARCH}" = "arm" -o "${ARCH}" = "mips" -o "${ARCH}" = "ia64" ]
482 then
483 # these archs will always have "[Pp]rocessor"
484 jobs="$((`grep -c ^[Pp]rocessor /proc/cpuinfo` * 2))"
485
486 elif [ "${ARCH}" = "sparc" -o "${ARCH}" = "sparc64" ]
487 then
488 # sparc always has "ncpus active"
489 jobs="$((`grep "^ncpus active" /proc/cpuinfo | sed -e "s/^.*: //"` * 2))"
490
491 elif [ "${ARCH}" = "alpha" ]
492 then
493 # alpha has "cpus active", but only when compiled with SMP
494 if [ "`grep -c "^cpus active" /proc/cpuinfo`" -eq 1 ]
495 then
496 jobs="$((`grep "^cpus active" /proc/cpuinfo | sed -e "s/^.*: //"` * 2))"
497 else
498 jobs=2
499 fi
500
501 elif [ "${ARCH}" = "ppc" -o "${ARCH}" = "ppc64" ]
502 then
503 # ppc has "processor", but only when compiled with SMP
504 if [ "`grep -c "^processor" /proc/cpuinfo`" -eq 1 ]
505 then
506 jobs="$((`grep -c ^processor /proc/cpuinfo` * 2))"
507 else
508 jobs=2
509 fi
510 elif [ "${ARCH}" = "s390" ]
511 then
512 # s390 has "# processors : "
513 jobs="$((`grep "^\# processors" /proc/cpuinfo | sed -e "s/^.*: //"` * 2))"
514 else
515 jobs="$((`grep -c ^cpu /proc/cpuinfo` * 2))"
516 die "Unknown ARCH -- ${ARCH}!"
517 fi
518
519 # Make sure the number is valid ...
520 if [ "${jobs}" -lt 1 ]
521 then
522 jobs=1
523 fi
524
525 if [ -n "${ADMINPARAM}" ]
526 then
527 if [ "${jobs}" -gt "${ADMINPARAM}" ]
528 then
529 einfo "Setting make jobs to \"-j${ADMINPARAM}\" to ensure successful merge ..."
530 export MAKEOPTS="${MAKEOPTS} -j${ADMINPARAM}"
531 else
532 einfo "Setting make jobs to \"-j${jobs}\" to ensure successful merge ..."
533 export MAKEOPTS="${MAKEOPTS} -j${jobs}"
534 fi
535 fi
536}
537
538# Cheap replacement for when debianutils (and thus mktemp) 377# Cheap replacement for when debianutils (and thus mktemp)
539# does not exist on the users system 378# does not exist on the users system
540# vapier@gentoo.org 379# vapier@gentoo.org
541# 380#
542# Takes just 1 optional parameter (the directory to create tmpfile in) 381# Takes just 1 optional parameter (the directory to create tmpfile in)
543emktemp() { 382emktemp() {
544 local exe="touch" 383 local exe="touch"
545 [ "$1" == "-d" ] && exe="mkdir" && shift 384 [[ $1 == -d ]] && exe="mkdir" && shift
546 local topdir="$1" 385 local topdir=$1
547 386
548 if [ -z "${topdir}" ] 387 if [[ -z ${topdir} ]] ; then
549 then
550 [ -z "${T}" ] \ 388 [[ -z ${T} ]] \
551 && topdir="/tmp" \ 389 && topdir="/tmp" \
552 || topdir="${T}" 390 || topdir=${T}
553 fi 391 fi
554 392
555 if [ -z "$(type -p mktemp)" ] 393 if [[ -z $(type -p mktemp) ]] ; then
556 then
557 local tmp=/ 394 local tmp=/
558 while [ -e "${tmp}" ] ; do 395 while [[ -e ${tmp} ]] ; do
559 tmp="${topdir}/tmp.${RANDOM}.${RANDOM}.${RANDOM}" 396 tmp=${topdir}/tmp.${RANDOM}.${RANDOM}.${RANDOM}
560 done 397 done
561 ${exe} "${tmp}" 398 ${exe} "${tmp}" || ${exe} -p "${tmp}"
562 echo "${tmp}" 399 echo "${tmp}"
563 else 400 else
564 [ "${exe}" == "touch" ] \ 401 [[ ${exe} == "touch" ]] \
565 && exe="-p" \ 402 && exe="-p" \
566 || exe="-d" 403 || exe="-d"
567 mktemp ${exe} "${topdir}" 404 mktemp ${exe} "${topdir}"
568 fi 405 fi
569} 406}
573# Joe Jezak <josejx@gmail.com> and usata@gentoo.org 410# Joe Jezak <josejx@gmail.com> and usata@gentoo.org
574# FBSD stuff: Aaron Walker <ka0ttic@gentoo.org> 411# FBSD stuff: Aaron Walker <ka0ttic@gentoo.org>
575# 412#
576# egetent(database, key) 413# egetent(database, key)
577egetent() { 414egetent() {
578 if useq ppc-macos ; then 415 case ${CHOST} in
416 *-darwin*)
579 case "$2" in 417 case "$2" in
580 *[!0-9]*) # Non numeric 418 *[!0-9]*) # Non numeric
581 nidump $1 . | awk -F":" "{ if (\$1 ~ /^$2$/) {print \$0;exit;} }" 419 nidump $1 . | awk -F":" "{ if (\$1 ~ /^$2$/) {print \$0;exit;} }"
582 ;; 420 ;;
583 *) # Numeric 421 *) # Numeric
584 nidump $1 . | awk -F":" "{ if (\$3 == $2) {print \$0;exit;} }" 422 nidump $1 . | awk -F":" "{ if (\$3 == $2) {print \$0;exit;} }"
585 ;; 423 ;;
586 esac 424 esac
587 elif useq x86-fbsd ; then 425 ;;
588 local action 426 *-freebsd*)
589 if [ "$1" == "passwd" ] 427 local opts action="user"
590 then 428 [[ $1 == "passwd" ]] || action="group"
591 action="user" 429
592 else 430 # lookup by uid/gid
593 action="group" 431 if [[ $2 == [[:digit:]]* ]] ; then
432 [[ ${action} == "user" ]] && opts="-u" || opts="-g"
594 fi 433 fi
434
595 pw show "${action}" "$2" -q 435 pw show ${action} ${opts} "$2" -q
596 else 436 ;;
437 *-netbsd*|*-openbsd*)
438 grep "$2:\*:" /etc/$1
439 ;;
440 *)
597 which nscd >& /dev/null && nscd -i "$1" 441 type -p nscd >& /dev/null && nscd -i "$1"
598 getent "$1" "$2" 442 getent "$1" "$2"
599 fi 443 ;;
444 esac
600} 445}
601 446
602# Simplify/standardize adding users to the system 447# Simplify/standardize adding users to the system
603# vapier@gentoo.org 448# vapier@gentoo.org
604# 449#
612# homedir: /dev/null 457# homedir: /dev/null
613# groups: none 458# groups: none
614# extra: comment of 'added by portage for ${PN}' 459# extra: comment of 'added by portage for ${PN}'
615enewuser() { 460enewuser() {
616 # get the username 461 # get the username
617 local euser="$1"; shift 462 local euser=$1; shift
618 if [ -z "${euser}" ] 463 if [[ -z ${euser} ]] ; then
619 then
620 eerror "No username specified !" 464 eerror "No username specified !"
621 die "Cannot call enewuser without a username" 465 die "Cannot call enewuser without a username"
622 fi 466 fi
623 467
624 # lets see if the username already exists 468 # lets see if the username already exists
625 if [ "${euser}" == "`egetent passwd \"${euser}\" | cut -d: -f1`" ] 469 if [[ ${euser} == $(egetent passwd "${euser}" | cut -d: -f1) ]] ; then
626 then
627 return 0 470 return 0
628 fi 471 fi
629 einfo "Adding user '${euser}' to your system ..." 472 einfo "Adding user '${euser}' to your system ..."
630 473
631 # options to pass to useradd 474 # options to pass to useradd
632 local opts= 475 local opts=
633 476
634 # handle uid 477 # handle uid
635 local euid="$1"; shift 478 local euid=$1; shift
636 if [ ! -z "${euid}" ] && [ "${euid}" != "-1" ] 479 if [[ ! -z ${euid} ]] && [[ ${euid} != "-1" ]] ; then
637 then
638 if [ "${euid}" -gt 0 ] 480 if [[ ${euid} -gt 0 ]] ; then
639 then
640 if [ ! -z "`egetent passwd ${euid}`" ] 481 if [[ ! -z $(egetent passwd ${euid}) ]] ; then
641 then
642 euid="next" 482 euid="next"
643 fi 483 fi
644 else 484 else
645 eerror "Userid given but is not greater than 0 !" 485 eerror "Userid given but is not greater than 0 !"
646 die "${euid} is not a valid UID" 486 die "${euid} is not a valid UID"
647 fi 487 fi
648 else 488 else
649 euid="next" 489 euid="next"
650 fi 490 fi
651 if [ "${euid}" == "next" ] 491 if [[ ${euid} == "next" ]] ; then
652 then 492 for euid in $(seq 101 999) ; do
653 local pwrange
654 if [ "${USERLAND}" == "BSD" ] ; then
655 pwrange="`jot 898 101`"
656 else
657 pwrange="`seq 101 999`"
658 fi
659 for euid in ${pwrange} ; do
660 [ -z "`egetent passwd ${euid}`" ] && break 493 [[ -z $(egetent passwd ${euid}) ]] && break
661 done 494 done
662 fi 495 fi
663 opts="${opts} -u ${euid}" 496 opts="${opts} -u ${euid}"
664 einfo " - Userid: ${euid}" 497 einfo " - Userid: ${euid}"
665 498
666 # handle shell 499 # handle shell
667 local eshell="$1"; shift 500 local eshell=$1; shift
668 if [ ! -z "${eshell}" ] && [ "${eshell}" != "-1" ] 501 if [[ ! -z ${eshell} ]] && [[ ${eshell} != "-1" ]] ; then
669 then
670 if [ ! -e "${eshell}" ] 502 if [[ ! -e ${eshell} ]] ; then
671 then
672 eerror "A shell was specified but it does not exist !" 503 eerror "A shell was specified but it does not exist !"
673 die "${eshell} does not exist" 504 die "${eshell} does not exist"
674 fi 505 fi
675 else 506 else
676 if [ "${USERLAND}" == "BSD" ] 507 for shell in /sbin/nologin /usr/sbin/nologin /bin/false /usr/bin/false /dev/null ; do
677 then 508 [[ -x ${ROOT}${shell} ]] && break
678 eshell="/usr/bin/false" 509 done
679 else 510
680 eshell="/bin/false" 511 if [[ ${shell} == "/dev/null" ]] ; then
512 eerror "Unable to identify the shell to use"
513 die "Unable to identify the shell to use"
681 fi 514 fi
515
516 eshell=${shell}
682 fi 517 fi
683 einfo " - Shell: ${eshell}" 518 einfo " - Shell: ${eshell}"
684 opts="${opts} -s ${eshell}" 519 opts="${opts} -s ${eshell}"
685 520
686 # handle homedir 521 # handle homedir
687 local ehome="$1"; shift 522 local ehome=$1; shift
688 if [ -z "${ehome}" ] && [ "${eshell}" != "-1" ] 523 if [[ -z ${ehome} ]] || [[ ${ehome} == "-1" ]] ; then
689 then
690 ehome="/dev/null" 524 ehome="/dev/null"
691 fi 525 fi
692 einfo " - Home: ${ehome}" 526 einfo " - Home: ${ehome}"
693 opts="${opts} -d ${ehome}" 527 opts="${opts} -d ${ehome}"
694 528
695 # handle groups 529 # handle groups
696 local egroups="$1"; shift 530 local egroups=$1; shift
697 if [ ! -z "${egroups}" ] 531 if [[ ! -z ${egroups} ]] ; then
698 then
699 local oldifs="${IFS}" 532 local oldifs=${IFS}
700 local defgroup="" exgroups="" 533 local defgroup="" exgroups=""
701 534
702 export IFS="," 535 export IFS=","
703 for g in ${egroups} 536 for g in ${egroups} ; do
704 do
705 export IFS="${oldifs}" 537 export IFS=${oldifs}
706 if [ -z "`egetent group \"${g}\"`" ] 538 if [[ -z $(egetent group "${g}") ]] ; then
707 then
708 eerror "You must add group ${g} to the system first" 539 eerror "You must add group ${g} to the system first"
709 die "${g} is not a valid GID" 540 die "${g} is not a valid GID"
710 fi 541 fi
711 if [ -z "${defgroup}" ] 542 if [[ -z ${defgroup} ]] ; then
712 then
713 defgroup="${g}" 543 defgroup=${g}
714 else 544 else
715 exgroups="${exgroups},${g}" 545 exgroups="${exgroups},${g}"
716 fi 546 fi
717 export IFS="," 547 export IFS=","
718 done 548 done
719 export IFS="${oldifs}" 549 export IFS=${oldifs}
720 550
721 opts="${opts} -g ${defgroup}" 551 opts="${opts} -g ${defgroup}"
722 if [ ! -z "${exgroups}" ] 552 if [[ ! -z ${exgroups} ]] ; then
723 then
724 opts="${opts} -G ${exgroups:1}" 553 opts="${opts} -G ${exgroups:1}"
725 fi 554 fi
726 else 555 else
727 egroups="(none)" 556 egroups="(none)"
728 fi 557 fi
729 einfo " - Groups: ${egroups}" 558 einfo " - Groups: ${egroups}"
730 559
731 # handle extra and add the user 560 # handle extra and add the user
732 local eextra="$@"
733 local oldsandbox="${SANDBOX_ON}" 561 local oldsandbox=${SANDBOX_ON}
734 export SANDBOX_ON="0" 562 export SANDBOX_ON="0"
735 if useq ppc-macos 563 case ${CHOST} in
736 then 564 *-darwin*)
737 ### Make the user 565 ### Make the user
738 if [ -z "${eextra}" ] 566 if [[ -z $@ ]] ; then
739 then
740 dscl . create /users/${euser} uid ${euid} 567 dscl . create /users/${euser} uid ${euid}
741 dscl . create /users/${euser} shell ${eshell} 568 dscl . create /users/${euser} shell ${eshell}
742 dscl . create /users/${euser} home ${ehome} 569 dscl . create /users/${euser} home ${ehome}
743 dscl . create /users/${euser} realname "added by portage for ${PN}" 570 dscl . create /users/${euser} realname "added by portage for ${PN}"
744 ### Add the user to the groups specified 571 ### Add the user to the groups specified
745 local oldifs="${IFS}" 572 local oldifs=${IFS}
746 export IFS="," 573 export IFS=","
747 for g in ${egroups} 574 for g in ${egroups} ; do
748 do
749 dscl . merge /groups/${g} users ${euser} 575 dscl . merge /groups/${g} users ${euser}
750 done 576 done
751 export IFS="${oldifs}" 577 export IFS=${oldifs}
752 else 578 else
753 einfo "Extra options are not supported on macos yet" 579 einfo "Extra options are not supported on Darwin yet"
754 einfo "Please report the ebuild along with the info below" 580 einfo "Please report the ebuild along with the info below"
755 einfo "eextra: ${eextra}" 581 einfo "eextra: $@"
756 die "Required function missing" 582 die "Required function missing"
757 fi 583 fi
758 elif use x86-fbsd ; then 584 ;;
759 if [ -z "${eextra}" ] 585 *-freebsd*)
760 then 586 if [[ -z $@ ]] ; then
761 pw useradd ${euser} ${opts} \ 587 pw useradd ${euser} ${opts} \
762 -c "added by portage for ${PN}" \ 588 -c "added by portage for ${PN}" \
763 die "enewuser failed" 589 die "enewuser failed"
764 else 590 else
765 einfo " - Extra: ${eextra}" 591 einfo " - Extra: $@"
766 pw useradd ${euser} ${opts} \ 592 pw useradd ${euser} ${opts} \
767 -c ${eextra} || die "enewuser failed" 593 "$@" || die "enewuser failed"
768 fi 594 fi
595 ;;
596
597 *-netbsd*)
598 if [[ -z $@ ]] ; then
599 useradd ${opts} ${euser} || die "enewuser failed"
769 else 600 else
770 if [ -z "${eextra}" ] 601 einfo " - Extra: $@"
771 then 602 useradd ${opts} ${euser} "$@" || die "enewuser failed"
603 fi
604 ;;
605
606 *-openbsd*)
607 if [[ -z $@ ]] ; then
608 useradd -u ${euid} -s ${eshell} \
609 -d ${ehome} -c "Added by portage for ${PN}" \
610 -g ${egroups} ${euser} || die "enewuser failed"
611 else
612 einfo " - Extra: $@"
613 useradd -u ${euid} -s ${eshell} \
614 -d ${ehome} -c "Added by portage for ${PN}" \
615 -g ${egroups} ${euser} "$@" || die "enewuser failed"
616 fi
617 ;;
618
619 *)
620 if [[ -z $@ ]] ; then
772 useradd ${opts} ${euser} \ 621 useradd ${opts} ${euser} \
773 -c "added by portage for ${PN}" \ 622 -c "added by portage for ${PN}" \
774 || die "enewuser failed" 623 || die "enewuser failed"
775 else 624 else
776 einfo " - Extra: ${eextra}" 625 einfo " - Extra: $@"
777 useradd ${opts} ${euser} ${eextra} \ 626 useradd ${opts} ${euser} "$@" \
778 || die "enewuser failed" 627 || die "enewuser failed"
779 fi 628 fi
629 ;;
630 esac
631
632 if [[ ! -e ${ROOT}/${ehome} ]] ; then
633 einfo " - Creating ${ehome} in ${ROOT}"
634 mkdir -p "${ROOT}/${ehome}"
635 chown ${euser} "${ROOT}/${ehome}"
636 chmod 755 "${ROOT}/${ehome}"
780 fi 637 fi
638
781 export SANDBOX_ON="${oldsandbox}" 639 export SANDBOX_ON=${oldsandbox}
782
783 if [ ! -e "${ehome}" ] && [ ! -e "${D}/${ehome}" ]
784 then
785 einfo " - Creating ${ehome} in ${D}"
786 dodir ${ehome}
787 fowners ${euser} ${ehome}
788 fperms 755 ${ehome}
789 fi
790} 640}
791 641
792# Simplify/standardize adding groups to the system 642# Simplify/standardize adding groups to the system
793# vapier@gentoo.org 643# vapier@gentoo.org
794# 644#
823 then 673 then
824 if [ "${egid}" -gt 0 ] 674 if [ "${egid}" -gt 0 ]
825 then 675 then
826 if [ -z "`egetent group ${egid}`" ] 676 if [ -z "`egetent group ${egid}`" ]
827 then 677 then
828 if useq ppc-macos ; then 678 if [[ "${CHOST}" == *-darwin* ]]; then
829 opts="${opts} ${egid}" 679 opts="${opts} ${egid}"
830 else 680 else
831 opts="${opts} -g ${egid}" 681 opts="${opts} -g ${egid}"
832 fi 682 fi
833 else 683 else
847 opts="${opts} ${eextra}" 697 opts="${opts} ${eextra}"
848 698
849 # add the group 699 # add the group
850 local oldsandbox="${SANDBOX_ON}" 700 local oldsandbox="${SANDBOX_ON}"
851 export SANDBOX_ON="0" 701 export SANDBOX_ON="0"
852 if useq ppc-macos ; then 702 case ${CHOST} in
703 *-darwin*)
853 if [ ! -z "${eextra}" ]; 704 if [ ! -z "${eextra}" ];
854 then 705 then
855 einfo "Extra options are not supported on macos yet" 706 einfo "Extra options are not supported on Darwin/OS X yet"
856 einfo "Please report the ebuild along with the info below" 707 einfo "Please report the ebuild along with the info below"
857 einfo "eextra: ${eextra}" 708 einfo "eextra: ${eextra}"
858 die "Required function missing" 709 die "Required function missing"
859 fi 710 fi
860 711
861 # If we need the next available 712 # If we need the next available
862 case ${egid} in 713 case ${egid} in
863 *[!0-9]*) # Non numeric 714 *[!0-9]*) # Non numeric
864 for egid in `jot 898 101`; do 715 for egid in $(seq 101 999); do
865 [ -z "`egetent group ${egid}`" ] && break 716 [ -z "`egetent group ${egid}`" ] && break
866 done 717 done
867 esac 718 esac
868 dscl . create /groups/${egroup} gid ${egid} 719 dscl . create /groups/${egroup} gid ${egid}
869 dscl . create /groups/${egroup} passwd '*' 720 dscl . create /groups/${egroup} passwd '*'
870 elif use x86-fbsd ; then 721 ;;
722
723 *-freebsd*)
871 case ${egid} in 724 case ${egid} in
872 *[!0-9]*) # Non numeric 725 *[!0-9]*) # Non numeric
873 for egid in `jot 898 101`; do 726 for egid in $(seq 101 999); do
874 [ -z "`egetent group ${egid}`" ] && break 727 [ -z "`egetent group ${egid}`" ] && break
875 done 728 done
876 esac 729 esac
877 pw groupadd ${egroup} -g ${egid} || die "enewgroup failed" 730 pw groupadd ${egroup} -g ${egid} || die "enewgroup failed"
878 else 731 ;;
732
733 *-netbsd*)
734 case ${egid} in
735 *[!0-9]*) # Non numeric
736 for egid in $(seq 101 999); do
737 [ -z "`egetent group ${egid}`" ] && break
738 done
739 esac
740 groupadd -g ${egid} ${egroup} || die "enewgroup failed"
741 ;;
742
743 *)
879 groupadd ${opts} ${egroup} || die "enewgroup failed" 744 groupadd ${opts} ${egroup} || die "enewgroup failed"
880 fi 745 ;;
746 esac
881 export SANDBOX_ON="${oldsandbox}" 747 export SANDBOX_ON="${oldsandbox}"
882} 748}
883 749
884# Simple script to replace 'dos2unix' binaries 750# Simple script to replace 'dos2unix' binaries
885# vapier@gentoo.org 751# vapier@gentoo.org
910# name: the name that will show up in the menu 776# name: the name that will show up in the menu
911# icon: give your little like a pretty little icon ... 777# icon: give your little like a pretty little icon ...
912# this can be relative (to /usr/share/pixmaps) or 778# this can be relative (to /usr/share/pixmaps) or
913# a full path to an icon 779# a full path to an icon
914# type: what kind of application is this ? for categories: 780# type: what kind of application is this ? for categories:
915# http://www.freedesktop.org/wiki/Standards_2fmenu_2dspec 781# http://www.freedesktop.org/Standards/desktop-entry-spec
916# path: if your app needs to startup in a specific dir 782# path: if your app needs to startup in a specific dir
917make_desktop_entry() { 783make_desktop_entry() {
918 [[ -z $1 ]] && eerror "make_desktop_entry: You must specify the executable" && return 1 784 [[ -z $1 ]] && eerror "make_desktop_entry: You must specify the executable" && return 1
919 785
920 local exec=${1} 786 local exec=${1}
946 dev) 812 dev)
947 type="Development" 813 type="Development"
948 ;; 814 ;;
949 815
950 games) 816 games)
951 [[ -z ${path} ]] && path=${GAMES_BINDIR}
952
953 case ${catmin} in 817 case ${catmin} in
954 action) type=ActionGame;; 818 action) type=ActionGame;;
955 arcade) type=ArcadeGame;; 819 arcade) type=ArcadeGame;;
956 board) type=BoardGame;; 820 board) type=BoardGame;;
957 kid) type=KidsGame;; 821 kid) type=KidsGame;;
998 type="Network;${type}" 862 type="Network;${type}"
999 ;; 863 ;;
1000 864
1001 sci) 865 sci)
1002 case ${catmin} in 866 case ${catmin} in
1003 astro*) type=Astronomoy;; 867 astro*) type=Astronomy;;
1004 bio*) type=Biology;; 868 bio*) type=Biology;;
1005 calc*) type=Calculator;; 869 calc*) type=Calculator;;
1006 chem*) type=Chemistry;; 870 chem*) type=Chemistry;;
1007 geo*) type=Geology;; 871 geo*) type=Geology;;
1008 math*) type=Math;; 872 math*) type=Math;;
1022 *) 886 *)
1023 type= 887 type=
1024 ;; 888 ;;
1025 esac 889 esac
1026 fi 890 fi
1027 891 if [ "${SLOT}" == "0" ] ; then
892 local desktop_name="${PN}"
893 else
894 local desktop_name="${PN}-${SLOT}"
895 fi
1028 local desktop=${T}/${exec%% *}-${P}.desktop 896 local desktop=${T}/${exec%% *}-${desktop_name}.desktop
1029 897
1030echo "[Desktop Entry] 898echo "[Desktop Entry]
1031Encoding=UTF-8 899Encoding=UTF-8
1032Version=0.9.2 900Version=0.9.2
1033Name=${name} 901Name=${name}
1036Exec=${exec} 904Exec=${exec}
1037Path=${path} 905Path=${path}
1038Icon=${icon} 906Icon=${icon}
1039Categories=Application;${type};" > "${desktop}" 907Categories=Application;${type};" > "${desktop}"
1040 908
909 (
910 # wrap the env here so that the 'insinto' call
911 # doesn't corrupt the env of the caller
1041 insinto /usr/share/applications 912 insinto /usr/share/applications
1042 doins "${desktop}" 913 doins "${desktop}"
1043 914 )
1044 return 0
1045} 915}
1046 916
1047# Make a GDM/KDM Session file 917# Make a GDM/KDM Session file
1048# 918#
1049# make_desktop_entry(<title>, <command>) 919# make_desktop_entry(<title>, <command>)
1050# title: File to execute to start the Window Manager 920# title: File to execute to start the Window Manager
1051# command: Name of the Window Manager 921# command: Name of the Window Manager
1052 922
1053make_session_desktop() { 923make_session_desktop() {
1054
1055 [ -z "$1" ] && eerror "make_session_desktop: You must specify the title" && return 1 924 [[ -z $1 ]] && eerror "make_session_desktop: You must specify the title" && return 1
1056 [ -z "$2" ] && eerror "make_session_desktop: You must specify the command" && return 1 925 [[ -z $2 ]] && eerror "make_session_desktop: You must specify the command" && return 1
1057 926
1058 local title="${1}" 927 local title=$1
1059 local command="${2}" 928 local command=$2
1060 local desktop="${T}/${wm}.desktop" 929 local desktop=${T}/${wm}.desktop
1061 930
1062echo "[Desktop Entry] 931echo "[Desktop Entry]
1063Encoding=UTF-8 932Encoding=UTF-8
1064Name=${title} 933Name=${title}
1065Comment=This session logs you into ${title} 934Comment=This session logs you into ${title}
1067TryExec=${command} 936TryExec=${command}
1068Type=Application" > "${desktop}" 937Type=Application" > "${desktop}"
1069 938
1070 insinto /usr/share/xsessions 939 insinto /usr/share/xsessions
1071 doins "${desktop}" 940 doins "${desktop}"
1072
1073 return 0
1074} 941}
1075 942
1076domenu() { 943domenu() {
1077 local i 944 local i j
1078 local j
1079 insinto /usr/share/applications 945 insinto /usr/share/applications
1080 for i in ${@} 946 for i in "$@" ; do
1081 do
1082 if [ -f "${i}" ]; 947 if [[ -f ${i} ]] ; then
1083 then
1084 doins ${i} 948 doins "${i}"
1085 elif [ -d "${i}" ]; 949 elif [[ -d ${i} ]] ; then
1086 then
1087 for j in ${i}/*.desktop 950 for j in "${i}"/*.desktop ; do
1088 do
1089 doins ${j} 951 doins "${j}"
1090 done 952 done
1091 fi 953 fi
1092 done 954 done
1093} 955}
956newmenu() {
957 insinto /usr/share/applications
958 newins "$1" "$2"
959}
1094 960
1095doicon() { 961doicon() {
1096 local i 962 local i j
1097 local j
1098 insinto /usr/share/pixmaps 963 insinto /usr/share/pixmaps
1099 for i in ${@} 964 for i in "$@" ; do
1100 do
1101 if [ -f "${i}" ]; 965 if [[ -f ${i} ]] ; then
1102 then
1103 doins ${i} 966 doins "${i}"
1104 elif [ -d "${i}" ]; 967 elif [[ -d ${i} ]] ; then
1105 then
1106 for j in ${i}/*.png 968 for j in "${i}"/*.png ; do
1107 do
1108 doins ${j} 969 doins "${j}"
1109 done 970 done
1110 fi 971 fi
1111 done 972 done
973}
974newicon() {
975 insinto /usr/share/pixmaps
976 newins "$1" "$2"
1112} 977}
1113 978
1114############################################################## 979##############################################################
1115# END: Handle .desktop files and menu entries # 980# END: Handle .desktop files and menu entries #
1116############################################################## 981##############################################################
1117 982
1118 983
1119# for internal use only (unpack_pdv and unpack_makeself) 984# for internal use only (unpack_pdv and unpack_makeself)
1120find_unpackable_file() { 985find_unpackable_file() {
1121 local src="$1" 986 local src=$1
1122 if [ -z "${src}" ] 987 if [[ -z ${src} ]] ; then
1123 then
1124 src="${DISTDIR}/${A}" 988 src=${DISTDIR}/${A}
1125 else 989 else
1126 if [ -e "${DISTDIR}/${src}" ] 990 if [[ -e ${DISTDIR}/${src} ]] ; then
1127 then
1128 src="${DISTDIR}/${src}" 991 src=${DISTDIR}/${src}
1129 elif [ -e "${PWD}/${src}" ] 992 elif [[ -e ${PWD}/${src} ]] ; then
1130 then
1131 src="${PWD}/${src}" 993 src=${PWD}/${src}
1132 elif [ -e "${src}" ] 994 elif [[ -e ${src} ]] ; then
1133 then
1134 src="${src}" 995 src=${src}
1135 fi
1136 fi 996 fi
1137 [ ! -e "${src}" ] && die "Could not find requested archive ${src}" 997 fi
998 [[ ! -e ${src} ]] && return 1
1138 echo "${src}" 999 echo "${src}"
1139} 1000}
1140 1001
1141# Unpack those pesky pdv generated files ... 1002# Unpack those pesky pdv generated files ...
1142# They're self-unpacking programs with the binary package stuffed in 1003# They're self-unpacking programs with the binary package stuffed in
1157# lseek 1018# lseek
1158# root@vapier 0 pdv_unpack # strace -elseek ./hldsupdatetool.bin 1019# root@vapier 0 pdv_unpack # strace -elseek ./hldsupdatetool.bin
1159# lseek(3, -4, SEEK_END) = 2981250 1020# lseek(3, -4, SEEK_END) = 2981250
1160# thus we would pass in the value of '4' as the second parameter. 1021# thus we would pass in the value of '4' as the second parameter.
1161unpack_pdv() { 1022unpack_pdv() {
1162 local src="`find_unpackable_file $1`" 1023 local src=$(find_unpackable_file $1)
1163 local sizeoff_t="$2" 1024 local sizeoff_t=$2
1164 1025
1026 [[ -z ${src} ]] && die "Could not locate source for '$1'"
1165 [ -z "${sizeoff_t}" ] && die "No idea what off_t size was used for this pdv :(" 1027 [[ -z ${sizeoff_t} ]] && die "No idea what off_t size was used for this pdv :("
1166 1028
1167 local shrtsrc="`basename ${src}`" 1029 local shrtsrc=$(basename "${src}")
1168 echo ">>> Unpacking ${shrtsrc} to ${PWD}" 1030 echo ">>> Unpacking ${shrtsrc} to ${PWD}"
1169 local metaskip=`tail -c ${sizeoff_t} ${src} | hexdump -e \"%i\"` 1031 local metaskip=`tail -c ${sizeoff_t} ${src} | hexdump -e \"%i\"`
1170 local tailskip=`tail -c $((${sizeoff_t}*2)) ${src} | head -c ${sizeoff_t} | hexdump -e \"%i\"` 1032 local tailskip=`tail -c $((${sizeoff_t}*2)) ${src} | head -c ${sizeoff_t} | hexdump -e \"%i\"`
1171 1033
1172 # grab metadata for debug reasons 1034 # grab metadata for debug reasons
1236# Usage: unpack_makeself [file to unpack] [offset] [tail|dd] 1098# Usage: unpack_makeself [file to unpack] [offset] [tail|dd]
1237# - If the file is not specified then unpack will utilize ${A}. 1099# - If the file is not specified then unpack will utilize ${A}.
1238# - If the offset is not specified then we will attempt to extract 1100# - If the offset is not specified then we will attempt to extract
1239# the proper offset from the script itself. 1101# the proper offset from the script itself.
1240unpack_makeself() { 1102unpack_makeself() {
1103 local src_input=${1:-${A}}
1241 local src="$(find_unpackable_file "$1")" 1104 local src=$(find_unpackable_file "${src_input}")
1242 local skip="$2" 1105 local skip=$2
1243 local exe="$3" 1106 local exe=$3
1244 1107
1108 [[ -z ${src} ]] && die "Could not locate source for '${src_input}'"
1109
1245 local shrtsrc="$(basename "${src}")" 1110 local shrtsrc=$(basename "${src}")
1246 echo ">>> Unpacking ${shrtsrc} to ${PWD}" 1111 echo ">>> Unpacking ${shrtsrc} to ${PWD}"
1247 if [ -z "${skip}" ] 1112 if [[ -z ${skip} ]] ; then
1248 then
1249 local ver="`grep -a '#.*Makeself' ${src} | awk '{print $NF}'`" 1113 local ver=$(grep -a '#.*Makeself' "${src}" | awk '{print $NF}')
1250 local skip=0 1114 local skip=0
1251 exe=tail 1115 exe=tail
1252 case ${ver} in 1116 case ${ver} in
1253 1.5.*) # tested 1.5.{3,4,5} ... guessing 1.5.x series is same 1117 1.5.*) # tested 1.5.{3,4,5} ... guessing 1.5.x series is same
1254 skip=$(grep -a ^skip= "${src}" | cut -d= -f2) 1118 skip=$(grep -a ^skip= "${src}" | cut -d= -f2)
1266 ;; 1130 ;;
1267 2.1.3) 1131 2.1.3)
1268 skip=`grep -a ^offset= "${src}" | awk '{print $3}'` 1132 skip=`grep -a ^offset= "${src}" | awk '{print $3}'`
1269 let skip="skip + 1" 1133 let skip="skip + 1"
1270 ;; 1134 ;;
1271 2.1.4) 1135 2.1.4|2.1.5)
1272 skip=$(grep -a offset=.*head.*wc "${src}" | awk '{print $3}' | head -n 1) 1136 skip=$(grep -a offset=.*head.*wc "${src}" | awk '{print $3}' | head -n 1)
1273 skip=$(head -n ${skip} "${src}" | wc -c) 1137 skip=$(head -n ${skip} "${src}" | wc -c)
1274 exe="dd" 1138 exe="dd"
1275 ;; 1139 ;;
1276 *) 1140 *)
1321check_license() { 1185check_license() {
1322 local lic=$1 1186 local lic=$1
1323 if [ -z "${lic}" ] ; then 1187 if [ -z "${lic}" ] ; then
1324 lic="${PORTDIR}/licenses/${LICENSE}" 1188 lic="${PORTDIR}/licenses/${LICENSE}"
1325 else 1189 else
1326 if [ -e "${PORTDIR}/licenses/${src}" ] ; then 1190 if [ -e "${PORTDIR}/licenses/${lic}" ] ; then
1327 lic="${PORTDIR}/licenses/${src}" 1191 lic="${PORTDIR}/licenses/${lic}"
1328 elif [ -e "${PWD}/${src}" ] ; then 1192 elif [ -e "${PWD}/${lic}" ] ; then
1329 lic="${PWD}/${src}" 1193 lic="${PWD}/${lic}"
1330 elif [ -e "${src}" ] ; then 1194 elif [ -e "${lic}" ] ; then
1331 lic="${src}" 1195 lic="${lic}"
1332 fi
1333 fi 1196 fi
1197 fi
1334 [ ! -f "${lic}" ] && die "Could not find requested license ${src}" 1198 [ ! -f "${lic}" ] && die "Could not find requested license ${lic}"
1335 local l="`basename ${lic}`" 1199 local l="`basename ${lic}`"
1336 1200
1337 # here is where we check for the licenses the user already 1201 # here is where we check for the licenses the user already
1338 # accepted ... if we don't find a match, we make the user accept 1202 # accepted ... if we don't find a match, we make the user accept
1339 local shopts=$- 1203 local shopts=$-
1395 # first we figure out how many cds we're dealing with by 1259 # first we figure out how many cds we're dealing with by
1396 # the # of files they gave us 1260 # the # of files they gave us
1397 local cdcnt=0 1261 local cdcnt=0
1398 local f= 1262 local f=
1399 for f in "$@" ; do 1263 for f in "$@" ; do
1400 cdcnt=$((cdcnt + 1)) 1264 ((++cdcnt))
1401 export CDROM_CHECK_${cdcnt}="$f" 1265 export CDROM_CHECK_${cdcnt}="$f"
1402 done 1266 done
1403 export CDROM_TOTAL_CDS=${cdcnt} 1267 export CDROM_TOTAL_CDS=${cdcnt}
1404 export CDROM_CURRENT_CD=1 1268 export CDROM_CURRENT_CD=1
1405 1269
1406 # now we see if the user gave use CD_ROOT ... 1270 # now we see if the user gave use CD_ROOT ...
1407 # if they did, let's just believe them that it's correct 1271 # if they did, let's just believe them that it's correct
1408 if [[ ! -z ${CD_ROOT} ]] ; then
1409 export CDROM_ROOT=${CD_ROOT}
1410 einfo "Found CD #${CDROM_CURRENT_CD} root at ${CDROM_ROOT}"
1411 return
1412 fi
1413 # do the same for CD_ROOT_X
1414 if [[ ! -z ${CD_ROOT_1} ]] ; then 1272 if [[ -n ${CD_ROOT}${CD_ROOT_1} ]] ; then
1415 local var= 1273 local var=
1416 cdcnt=0 1274 cdcnt=0
1417 while [[ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ]] ; do 1275 while [[ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ]] ; do
1418 cdcnt=$((cdcnt + 1)) 1276 ((++cdcnt))
1419 var="CD_ROOT_${cdcnt}" 1277 var="CD_ROOT_${cdcnt}"
1278 [[ -z ${!var} ]] && var="CD_ROOT"
1420 if [[ -z ${!var} ]] ; then 1279 if [[ -z ${!var} ]] ; then
1421 eerror "You must either use just the CD_ROOT" 1280 eerror "You must either use just the CD_ROOT"
1422 eerror "or specify ALL the CD_ROOT_X variables." 1281 eerror "or specify ALL the CD_ROOT_X variables."
1423 eerror "In this case, you will need ${CDROM_TOTAL_CDS} CD_ROOT_X variables." 1282 eerror "In this case, you will need ${CDROM_TOTAL_CDS} CD_ROOT_X variables."
1424 die "could not locate CD_ROOT_${cdcnt}" 1283 die "could not locate CD_ROOT_${cdcnt}"
1425 fi 1284 fi
1426 export CDROM_ROOTS_${cdcnt}="${!var}"
1427 done 1285 done
1428 export CDROM_ROOT=${CDROM_ROOTS_1} 1286 export CDROM_ROOT=${CD_ROOT_1:-${CD_ROOT}}
1429 einfo "Found CD #${CDROM_CURRENT_CD} root at ${CDROM_ROOT}" 1287 einfo "Found CD #${CDROM_CURRENT_CD} root at ${CDROM_ROOT}"
1288 export CDROM_SET=-1
1289 for f in ${CDROM_CHECK_1//:/ } ; do
1290 ((++CDROM_SET))
1291 [[ -e ${CD_ROOT}/${f} ]] && break
1292 done
1293 export CDROM_MATCH=${f}
1430 return 1294 return
1431 fi 1295 fi
1432 1296
1297 # User didn't help us out so lets make sure they know they can
1298 # simplify the whole process ...
1433 if [[ ${CDROM_TOTAL_CDS} -eq 1 ]] ; then 1299 if [[ ${CDROM_TOTAL_CDS} -eq 1 ]] ; then
1434 einfon "This ebuild will need the " 1300 einfo "This ebuild will need the ${CDROM_NAME:-cdrom for ${PN}}"
1435 if [[ -z ${CDROM_NAME} ]] ; then
1436 echo "cdrom for ${PN}."
1437 else
1438 echo "${CDROM_NAME}."
1439 fi
1440 echo 1301 echo
1441 einfo "If you do not have the CD, but have the data files" 1302 einfo "If you do not have the CD, but have the data files"
1442 einfo "mounted somewhere on your filesystem, just export" 1303 einfo "mounted somewhere on your filesystem, just export"
1443 einfo "the variable CD_ROOT so that it points to the" 1304 einfo "the variable CD_ROOT so that it points to the"
1444 einfo "directory containing the files." 1305 einfo "directory containing the files."
1448 echo 1309 echo
1449 else 1310 else
1450 einfo "This package will need access to ${CDROM_TOTAL_CDS} cds." 1311 einfo "This package will need access to ${CDROM_TOTAL_CDS} cds."
1451 cdcnt=0 1312 cdcnt=0
1452 while [[ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ]] ; do 1313 while [[ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ]] ; do
1453 cdcnt=$((cdcnt + 1)) 1314 ((++cdcnt))
1454 var="CDROM_NAME_${cdcnt}" 1315 var="CDROM_NAME_${cdcnt}"
1455 [[ ! -z ${!var} ]] && einfo " CD ${cdcnt}: ${!var}" 1316 [[ ! -z ${!var} ]] && einfo " CD ${cdcnt}: ${!var}"
1456 done 1317 done
1457 echo 1318 echo
1458 einfo "If you do not have the CDs, but have the data files" 1319 einfo "If you do not have the CDs, but have the data files"
1459 einfo "mounted somewhere on your filesystem, just export" 1320 einfo "mounted somewhere on your filesystem, just export"
1460 einfo "the following variables so they point to the right place:" 1321 einfo "the following variables so they point to the right place:"
1461 einfon "" 1322 einfon ""
1462 cdcnt=0 1323 cdcnt=0
1463 while [[ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ]] ; do 1324 while [[ ${cdcnt} -lt ${CDROM_TOTAL_CDS} ]] ; do
1464 cdcnt=$((cdcnt + 1)) 1325 ((++cdcnt))
1465 echo -n " CD_ROOT_${cdcnt}" 1326 echo -n " CD_ROOT_${cdcnt}"
1466 done 1327 done
1467 echo 1328 echo
1468 einfo "Or, if you have all the files in the same place, or" 1329 einfo "Or, if you have all the files in the same place, or"
1469 einfo "you only have one cdrom, you can export CD_ROOT" 1330 einfo "you only have one cdrom, you can export CD_ROOT"
1472 echo 1333 echo
1473 einfo "For example:" 1334 einfo "For example:"
1474 einfo "export CD_ROOT_1=/mnt/cdrom" 1335 einfo "export CD_ROOT_1=/mnt/cdrom"
1475 echo 1336 echo
1476 fi 1337 fi
1338
1339 export CDROM_SET=""
1477 export CDROM_CURRENT_CD=0 1340 export CDROM_CURRENT_CD=0
1478 cdrom_load_next_cd 1341 cdrom_load_next_cd
1479} 1342}
1480 1343
1481# this is only used when you need access to more than one cd. 1344# this is only used when you need access to more than one cd.
1482# when you have finished using the first cd, just call this function. 1345# when you have finished using the first cd, just call this function.
1483# when it returns, CDROM_ROOT will be pointing to the second cd. 1346# when it returns, CDROM_ROOT will be pointing to the second cd.
1484# remember, you can only go forward in the cd chain, you can't go back. 1347# remember, you can only go forward in the cd chain, you can't go back.
1485cdrom_load_next_cd() { 1348cdrom_load_next_cd() {
1486 export CDROM_CURRENT_CD=$((CDROM_CURRENT_CD + 1))
1487 local var= 1349 local var
1488 1350 ((++CDROM_CURRENT_CD))
1489 if [[ ! -z ${CD_ROOT} ]] ; then
1490 einfo "Using same root as before for CD #${CDROM_CURRENT_CD}"
1491 return
1492 fi
1493 1351
1494 unset CDROM_ROOT 1352 unset CDROM_ROOT
1495 var=CDROM_ROOTS_${CDROM_CURRENT_CD} 1353 var=CD_ROOT_${CDROM_CURRENT_CD}
1354 [[ -z ${!var} ]] && var="CD_ROOT"
1496 if [[ -z ${!var} ]] ; then 1355 if [[ -z ${!var} ]] ; then
1497 var="CDROM_CHECK_${CDROM_CURRENT_CD}" 1356 var="CDROM_CHECK_${CDROM_CURRENT_CD}"
1498 cdrom_locate_file_on_cd ${!var} 1357 _cdrom_locate_file_on_cd ${!var}
1499 else 1358 else
1500 export CDROM_ROOT=${!var} 1359 export CDROM_ROOT=${!var}
1501 fi 1360 fi
1502 1361
1503 einfo "Found CD #${CDROM_CURRENT_CD} root at ${CDROM_ROOT}" 1362 einfo "Found CD #${CDROM_CURRENT_CD} root at ${CDROM_ROOT}"
1508# all it does is try to locate a give file on a cd ... if the cd isn't 1367# all it does is try to locate a give file on a cd ... if the cd isn't
1509# found, then a message asking for the user to insert the cdrom will be 1368# found, then a message asking for the user to insert the cdrom will be
1510# displayed and we'll hang out here until: 1369# displayed and we'll hang out here until:
1511# (1) the file is found on a mounted cdrom 1370# (1) the file is found on a mounted cdrom
1512# (2) the user hits CTRL+C 1371# (2) the user hits CTRL+C
1513cdrom_locate_file_on_cd() { 1372_cdrom_locate_file_on_cd() {
1373 local mline=""
1374 local showedmsg=0
1375
1514 while [[ -z ${CDROM_ROOT} ]] ; do 1376 while [[ -z ${CDROM_ROOT} ]] ; do
1377 local i=0
1378 local -a cdset=(${*//:/ })
1379 if [[ -n ${CDROM_SET} ]] ; then
1380 cdset=(${cdset[${CDROM_SET}]})
1381 fi
1382
1383 while [[ -n ${cdset[${i}]} ]] ; do
1515 local dir="$(dirname ${@})" 1384 local dir=$(dirname ${cdset[${i}]})
1516 local file="$(basename ${@})" 1385 local file=$(basename ${cdset[${i}]})
1517 local mline=""
1518 local showedmsg=0
1519 1386
1520 for mline in $(mount | egrep -e '(iso|cdrom)' | awk '{print $3}') ; do 1387 for mline in $(mount | gawk '/(iso|cdrom|fs=cdfss)/ {print $3}') ; do
1521 [[ -d ${mline}/${dir} ]] || continue 1388 [[ -d ${mline}/${dir} ]] || continue
1522 [[ ! -z $(find ${mline}/${dir} -iname ${file} -maxdepth 1) ]] \ 1389 if [[ -n $(find ${mline}/${dir} -maxdepth 1 -iname ${file}) ]] ; then
1523 && export CDROM_ROOT=${mline} 1390 export CDROM_ROOT=${mline}
1391 export CDROM_SET=${i}
1392 export CDROM_MATCH=${cdset[${i}]}
1393 return
1394 fi
1395 done
1396
1397 ((++i))
1524 done 1398 done
1525 1399
1526 if [[ -z ${CDROM_ROOT} ]] ; then
1527 echo 1400 echo
1528 if [[ ${showedmsg} -eq 0 ]] ; then 1401 if [[ ${showedmsg} -eq 0 ]] ; then
1529 if [[ ${CDROM_TOTAL_CDS} -eq 1 ]] ; then 1402 if [[ ${CDROM_TOTAL_CDS} -eq 1 ]] ; then
1530 if [[ -z ${CDROM_NAME} ]] ; then 1403 if [[ -z ${CDROM_NAME} ]] ; then
1531 einfo "Please insert the cdrom for ${PN} now !" 1404 einfo "Please insert+mount the cdrom for ${PN} now !"
1532 else
1533 einfo "Please insert the ${CDROM_NAME} cdrom now !"
1534 fi
1535 else 1405 else
1536 if [[ -z ${CDROM_NAME_1} ]] ; then
1537 einfo "Please insert cd #${CDROM_CURRENT_CD} for ${PN} now !"
1538 else
1539 local var="CDROM_NAME_${CDROM_CURRENT_CD}"
1540 einfo "Please insert+mount the ${!var} cdrom now !" 1406 einfo "Please insert+mount the ${CDROM_NAME} cdrom now !"
1541 fi
1542 fi 1407 fi
1543 showedmsg=1 1408 else
1409 if [[ -z ${CDROM_NAME_1} ]] ; then
1410 einfo "Please insert+mount cd #${CDROM_CURRENT_CD} for ${PN} now !"
1411 else
1412 local var="CDROM_NAME_${CDROM_CURRENT_CD}"
1413 einfo "Please insert+mount the ${!var} cdrom now !"
1414 fi
1544 fi 1415 fi
1416 showedmsg=1
1417 fi
1545 einfo "Press return to scan for the cd again" 1418 einfo "Press return to scan for the cd again"
1546 einfo "or hit CTRL+C to abort the emerge." 1419 einfo "or hit CTRL+C to abort the emerge."
1420 echo
1421 einfo "If you are having trouble with the detection"
1422 einfo "of your CD, it is possible that you do not have"
1423 einfo "Joliet support enabled in your kernel. Please"
1424 einfo "check that CONFIG_JOLIET is enabled in your kernel."
1547 read 1425 read
1548 fi
1549 done 1426 done
1550} 1427}
1551 1428
1552# Make sure that LINGUAS only contains languages that 1429# Make sure that LINGUAS only contains languages that
1553# a package can support 1430# a package can support
1595 else 1472 else
1596 ewarn "Sorry, but ${PN} does not support the ${f} LINGUA" 1473 ewarn "Sorry, but ${PN} does not support the ${f} LINGUA"
1597 fi 1474 fi
1598 done 1475 done
1599 if [[ -z ${newls} ]] ; then 1476 if [[ -z ${newls} ]] ; then
1600 unset LINGUAS 1477 export LINGUAS=""
1601 else 1478 else
1602 export LINGUAS=${newls:1} 1479 export LINGUAS=${newls:1}
1603 fi 1480 fi
1604} 1481}
1605 1482
1615 while ((i--)) ; do 1492 while ((i--)) ; do
1616 ewarn "PLEASE UPDATE TO YOUR PACKAGE TO USE linux-info.eclass" 1493 ewarn "PLEASE UPDATE TO YOUR PACKAGE TO USE linux-info.eclass"
1617 done 1494 done
1618 export EUTILS_ECLASS_PORTAGE_ARCH="${ARCH}" 1495 export EUTILS_ECLASS_PORTAGE_ARCH="${ARCH}"
1619 case ${ARCH} in 1496 case ${ARCH} in
1620 x86) export ARCH="i386";; 1497 x86) export ARCH="i386";;
1621 amd64) export ARCH="x86_64";; 1498 amd64) export ARCH="x86_64";;
1622 hppa) export ARCH="parisc";; 1499 hppa) export ARCH="parisc";;
1623 mips) export ARCH="mips";; 1500 mips) export ARCH="mips";;
1624 sparc) export ARCH="$(tc-arch-kernel)";; # Yeah this is ugly, but it's even WORSE if you don't do this. linux-info.eclass's set_arch_to_kernel is fixed, but won't get used over this one! 1501 sparc) export ARCH="$(tc-arch-kernel)";; # Yeah this is ugly, but it's even WORSE if you don't do this. linux-info.eclass's set_arch_to_kernel is fixed, but won't get used over this one!
1625 *) export ARCH="${ARCH}";; 1502 *) export ARCH="${ARCH}";;
1626 esac 1503 esac
1627} 1504}
1628 1505
1629# set's ARCH back to what portage expects 1506# set's ARCH back to what portage expects
1630set_arch_to_portage() { 1507set_arch_to_portage() {
1674 LIB=$1 1551 LIB=$1
1675 1552
1676 if [ -n "${LIB}" -a -f "${ROOT}${LIB}" ]; then 1553 if [ -n "${LIB}" -a -f "${ROOT}${LIB}" ]; then
1677 SONAME=`basename ${LIB}` 1554 SONAME=`basename ${LIB}`
1678 1555
1679 einfo "An old version of an installed library was detected on your system." 1556 ewarn "An old version of an installed library was detected on your system."
1680 einfo "In order to avoid breaking packages that link against is, this older version" 1557 ewarn "In order to avoid breaking packages that link against it, this older version"
1681 einfo "is not being removed. In order to make full use of this newer version," 1558 ewarn "is not being removed. In order to make full use of this newer version,"
1682 einfo "you will need to execute the following command:" 1559 ewarn "you will need to execute the following command:"
1683 einfo " revdep-rebuild --soname ${SONAME}" 1560 ewarn " revdep-rebuild --soname ${SONAME}"
1684 einfo 1561 ewarn
1685 einfo "After doing that, you can safely remove ${LIB}" 1562 ewarn "After doing that, you can safely remove ${LIB}"
1686 einfo "Note: 'emerge gentoolkit' to get revdep-rebuild" 1563 ewarn "Note: 'emerge gentoolkit' to get revdep-rebuild"
1687 fi 1564 fi
1688} 1565}
1689 1566
1690# Hack for people to figure out if a package was built with 1567# Hack for people to figure out if a package was built with
1691# certain USE flags 1568# certain USE flags
1701 [[ ${opt:0:1} = "-" ]] && shift || opt="-a" 1578 [[ ${opt:0:1} = "-" ]] && shift || opt="-a"
1702 1579
1703 local PKG=$(best_version $1) 1580 local PKG=$(best_version $1)
1704 shift 1581 shift
1705 1582
1706 local USEFILE="${ROOT}/var/db/pkg/${PKG}/USE" 1583 local USEFILE=${ROOT}/var/db/pkg/${PKG}/USE
1584
1585 # if the USE file doesnt exist, assume the $PKG is either
1586 # injected or package.provided
1707 [[ ! -e ${USEFILE} ]] && return 1 1587 [[ ! -e ${USEFILE} ]] && return 0
1708 1588
1709 local USE_BUILT=$(<${USEFILE}) 1589 local USE_BUILT=$(<${USEFILE})
1710 while [[ $# -gt 0 ]] ; do 1590 while [[ $# -gt 0 ]] ; do
1711 if [[ ${opt} = "-o" ]] ; then 1591 if [[ ${opt} = "-o" ]] ; then
1712 has $1 ${USE_BUILT} && return 0 1592 has $1 ${USE_BUILT} && return 0
1737dopamd() { 1617dopamd() {
1738 [[ -z $1 ]] && die "dopamd requires at least one argument" 1618 [[ -z $1 ]] && die "dopamd requires at least one argument"
1739 1619
1740 use pam || return 0 1620 use pam || return 0
1741 1621
1742 insinto /etc/pam.d 1622 INSDESTTREE=/etc/pam.d \
1743 # these are the default doins options, but be explicit just in case
1744 insopts -m 0644 -o root -g root
1745 doins "$@" || die "failed to install $@" 1623 doins "$@" || die "failed to install $@"
1746} 1624}
1747# newpamd <old name> <new name> 1625# newpamd <old name> <new name>
1748# 1626#
1749# Install pam file <old name> as <new name> in /etc/pam.d 1627# Install pam file <old name> as <new name> in /etc/pam.d
1750newpamd() { 1628newpamd() {
1751 [[ $# -ne 2 ]] && die "newpamd requires two arguements" 1629 [[ $# -ne 2 ]] && die "newpamd requires two arguements"
1752 1630
1753 use pam || return 0 1631 use pam || return 0
1754 1632
1755 insinto /etc/pam.d 1633 INSDESTTREE=/etc/pam.d \
1756 # these are the default doins options, but be explicit just in case
1757 insopts -m 0644 -o root -g root
1758 newins "$1" "$2" || die "failed to install $1 as $2" 1634 newins "$1" "$2" || die "failed to install $1 as $2"
1759} 1635}
1636
1637# make a wrapper script ...
1638# NOTE: this was originally games_make_wrapper, but I noticed other places where
1639# this could be used, so I have moved it here and made it not games-specific
1640# -- wolf31o2
1641# $1 == wrapper name
1642# $2 == binary to run
1643# $3 == directory to chdir before running binary
1644# $4 == extra LD_LIBRARY_PATH's (make it : delimited)
1645# $5 == path for wrapper
1646make_wrapper() {
1647 local wrapper=$1 bin=$2 chdir=$3 libdir=$4 path=$5
1648 local tmpwrapper=$(emktemp)
1649 # We don't want to quote ${bin} so that people can pass complex
1650 # things as $bin ... "./someprog --args"
1651 cat << EOF > "${tmpwrapper}"
1652#!/bin/sh
1653cd "${chdir:-.}"
1654if [ -n "${libdir}" ] ; then
1655 if [ "\${LD_LIBRARY_PATH+set}" = "set" ] ; then
1656 export LD_LIBRARY_PATH="\${LD_LIBRARY_PATH}:${libdir}"
1657 else
1658 export LD_LIBRARY_PATH="${libdir}"
1659 fi
1660fi
1661exec ${bin} "\$@"
1662EOF
1663 chmod go+rx "${tmpwrapper}"
1664 if [[ -n ${path} ]] ; then
1665 exeinto "${path}"
1666 newexe "${tmpwrapper}" "${wrapper}"
1667 else
1668 newbin "${tmpwrapper}" "${wrapper}"
1669 fi
1670}

Legend:
Removed from v.1.159  
changed lines
  Added in v.1.218

  ViewVC Help
Powered by ViewVC 1.1.20